
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java从零开始学四十(反射简述一) / 憋错料</title>

    <meta name="description" content="Java从零开始学四十(反射简述一) 一.JAVA是动态语言吗? 一般而言,说到动态言,都是指在程序运行时允许改变程序结构或者变量类型,从这个观点看,JAVA和C++一样,都不是动态语言. 但JAVA它却有着一个非常突出的动态相关机制:反射.通过反射,Java可以于运行时加载.探知和使用编译期间完全求和的类.生成其对象实体,调用其方法或者对属性设值.所以Java算是一个半动态的语言吧. 反射的概念: 在Java中的反射机制是指在运行状态中,对于任意一个类,都能够知道这个类的所有属性和方法; 对于任意一个对象,都能够调用它的任意一个方">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java从零开始学四十(反射简述一)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>一、JAVA是动态语言吗？</h3>
<p>一般而言，说到动态言，都是指在程序运行时允许改变程序结构或者变量类型，从这个观点看，JAVA和C++一样，都不是动态语言。</p>
<p>但JAVA它却有着一个非常突出的动态相关机制：反射。通过反射，Java可以于运行时加载、探知和使用编译期间完全求和的类、生成其对象实体，调用其方法或者对属性设值。所以Java算是一个半动态的语言吧。</p>
<p><strong>反射的概念：</strong></p>
<p><strong>在Java中的反射机制是指在运行状态中，对于任意一个类，都能够知道这个类的所有属性和方法;</strong></p>
<p><strong>对于任意一个对象，都能够调用它的任意一个方法;</strong></p>
<p><strong>这种动态获取信息以及动态调用对象方法的功能称为Java语言的反射机制</strong></p>
<h3>二、动态性质</h3>
<h4>2.1、动态性质</h4>
<ul>
<li>运行时生成对象实例;</li>
<li>运行期间调用方法；</li>
<li>运行时更改属性</li>
</ul>
<h4>2.2、Java反射机制能实现的功能</h4>
<ul>
<li>在运行时判断任意一个对象所属的类</li>
<li>在运行时构造任意一个类的对象</li>
<li>在运行时判断任意怀个类所具有的方法和属性</li>
<li>在运行时调用任意一个对象的方法</li>
<li>生成动态代理</li>
</ul>
<h4>2.3、Java反射应用场合</h4>
<p>在Java程序中许多对象在运行时都会出现两种类型：编译时类型和运行时类型</p>
<p>编译时的类型由声明该对象时使用的类型决定，运行时的类型由实际赋给对象的类型决定</p>
<p>如：</p>
<pre>Person p =new Student();</pre>
<p>编译时类型为Person，而运行时为Student</p>
<p>除此之外，程序在运行时还可能接收到外部传入的一个对象，该对象的编译时类型为Object，但程序又需要调用该对象运行时类型的方法。为了这些问题程序需要在运行时发现对象和类的真实信息。然而，如果编译时根本无法预知该对象和类可能属于哪些类，程序只依靠运行时信息来发现该对象和类的真实信息，此时就必须使用反射</p>
<h3>三、Java反射API</h3>
<p>反射API用来生成在当前JAVA虚拟机中的类、接口或者对象的信息。</p>
<ul>
<li><strong>Class类:反射的核心类，可以获取类的属性，方法等内容信息。</strong></li>
<li><strong>Field类:Java.lang.reflect.表示类的属性，可以获取和设置类的中属性值。</strong></li>
<li><strong>Method类:Java.lang.reflect。表示类的方法，它可以用来获取类中方法的信息或者执行方法</strong></li>
<li><strong>Construcor类:Java.lang.reflect。表示类的构造方法。</strong></li>
</ul>
<h3>四、获取全部方法和属性</h3>
<p>Person类</p>
<pre>package com.pb.Reflect.classinfo;

public class Person {
    private String name;
    private String gender;
    private int age;

    private Person() {
    //
    }
    public Person(String name, String gender, int age) {
        super();
        this.name = name;
        this.gender = gender;
        this.age = age;
    }
    //getter、和setter方法
    private String getName() {
        return name;
    }
    private void setName(String name) {
        this.name = name;
    }
    public String getGender() {
        return gender;
    }
    public void setGender(String gender) {
        this.gender = gender;
    }
    public int getAge() {
        return age;
    }
    public void setAge(int age) {
        this.age = age;
    }

    public String toString(){
        return "姓名："+name+"年龄: "+age;
    }

}</pre>
<p>使用反射:</p>
<pre>package com.pb.Reflect.classinfo;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import javax.swing.JOptionPane;

/*
 * 通过用户输入类的全路径，来获取该类的成员方法和属性
 * Declared获取全部不管是私有和公有
 * 1.获取访问类的Class对象
 * 2.调用Class对象的方法返回访问类的方法和属性信息
 */
public class ReflectDemo {

    /*
     * 构造方法
     */
    public ReflectDemo(){
        //用户输入类的全路径径
        //使用String组件
        String classpsth=JOptionPane.showInputDialog(null,"输入类的全路径");
        //使用Class.forName方法根据输入的类的全路径 返回该类的Class对象
        try {
            Class cla = Class.forName(classpsth);
            //利用Class对象的cla的自审,返回方法对象集合
            Method [] method=cla.getDeclaredMethods(); //返回所有的方法
            System.out.println("========获取方法信息============");
            for (Method meth : method) {
                //遍历method数组，并输出方法信息
                System.out.println(meth.toString());
            }
            System.out.println("========获取出方法信息结束============");
            //获取属性利用Class对象的cla的自审,返回成员属性对象集合
             Field [] field=cla.getDeclaredFields();
                System.out.println("========获取成员属性信息============");
                for (Field f : field) {
                    System.out.println(f.toString());
                }
                System.out.println("========获取成员属性信息结束============");
            //获取属性利用Class对象的cla的自审,返回构造方法集合
                Constructor [] constructor=cla.getDeclaredConstructors();
                System.out.println("========获取成员构造方法信息============");
                for (Constructor constru : constructor) {
                    System.out.println(constru.toString());
                }
                System.out.println("========获取成员构造方法信息结束============");
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            System.out.println("路径输入错误！");
        }
    }

}</pre>
<p>测试类:</p>
<pre>package com.pb.Reflect.classinfo;

public class TestReflection {

    public static void main(String[] args) {
        ReflectDemo rd=new ReflectDemo();

    }

}</pre>
<p>输入com.pb.Reflect.classinfo.Person</p>
<p>结果:</p>
<pre>========获取方法信息============
public java.lang.String com.pb.Reflect.classinfo.Person.getGender()
public void com.pb.Reflect.classinfo.Person.setGender(java.lang.String)
public int com.pb.Reflect.classinfo.Person.getAge()
public void com.pb.Reflect.classinfo.Person.setAge(int)
public java.lang.String com.pb.Reflect.classinfo.Person.toString()
private java.lang.String com.pb.Reflect.classinfo.Person.getName()
private void com.pb.Reflect.classinfo.Person.setName(java.lang.String)
========获取出方法信息结束============
========获取成员属性信息============
private java.lang.String com.pb.Reflect.classinfo.Person.name
private java.lang.String com.pb.Reflect.classinfo.Person.gender
private int com.pb.Reflect.classinfo.Person.age
========获取成员属性信息结束============
========获取构造方法信息============
private com.pb.Reflect.classinfo.Person()
public com.pb.Reflect.classinfo.Person(java.lang.String,java.lang.String,int)
========获取构造方法信息结束============</pre>

<h3>五、使用反射的步骤</h3>
<h4>5.1、步骤</h4>
<p><strong>Java.lang.reflect</strong></p>
<ul>
<li><strong>获得想操作类的Java.lang.Class对象</strong></li>
<li><strong>调用Class的方法</strong></li>
<li><strong>使用反射API来操作这些信息</strong></li>
</ul>
<h4>5.2、获取Class对象方式</h4>
<ul>
<li><strong>调用某个对象的getClass()方法</strong></li>
</ul>

<pre>Person p = new Person();
Class cla=p.getClass();</pre>

<ul>
<li><strong>调用某个类的class属性来获取该类对应的Class对象</strong></li>
</ul>

<pre>Class cls=Person.class;</pre>

<ul>
<li><strong>使用Class类的forName()静态方法</strong></li>
</ul>

<pre>Class cla=Class.forName(&ldquo;类的全路径&rdquo;);</pre>

<h3>六、第二种方式对象的getClass()方法</h3>
<p>Person类,因为要声明对象所以将构造方法public</p>
<pre>package com.pb.Reflect.classinfo;

public class Person {
    private String name;
    private String gender;
    private int age;

    public Person() {
    //
    }
    public Person(String name, String gender, int age) {
        super();
        this.name = name;
        this.gender = gender;
        this.age = age;
    }
    //getter、和setter方法
    private String getName() {
        return name;
    }
    private void setName(String name) {
        this.name = name;
    }
    public String getGender() {
        return gender;
    }
    public void setGender(String gender) {
        this.gender = gender;
    }
    public int getAge() {
        return age;
    }
    public void setAge(int age) {
        this.age = age;
    }

    public String toString(){
        return "姓名："+name+"年龄: "+age;
    }

}</pre>
<p>使用反射:</p>
<pre>package com.pb.Reflect.classinfo;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import javax.swing.JOptionPane;

/*
 * 通过用户输入类的全路径，来获取该类的成员方法和属性
 * Declared获取全部不管是私有和公有
 * 1.获取访问类的Class对象
 * 2.调用Class对象的方法返回访问类的方法和属性信息
 */

    public ReflectDemo(Person p){
        Class cla=p.getClass();
        //利用Class对象的cla的自审,返回方法对象集合
        Method [] method=cla.getDeclaredMethods(); //返回所有的方法
        System.out.println("========获取方法信息============");
        for (Method meth : method) {
            //遍历method数组，并输出方法信息
            System.out.println(meth.toString());
        }
        System.out.println("========获取出方法信息结束============");
        //获取属性利用Class对象的cla的自审,返回成员属性对象集合
         Field [] field=cla.getDeclaredFields();
            System.out.println("========获取成员属性信息============");
            for (Field f : field) {
                System.out.println(f.toString());
            }
            System.out.println("========获取成员属性信息结束============");
        //获取属性利用Class对象的cla的自审,返回构造方法集合
            Constructor [] constructor=cla.getDeclaredConstructors();
            System.out.println("========获取成员构造方法信息============");
            for (Constructor constru : constructor) {
                System.out.println(constru.toString());
            }
            System.out.println("========获取成员构造方法信息结束============");
    }

}</pre>
<p>测试类</p>
<pre>package com.pb.Reflect.classinfo;

public class TestReflection {

    public static void main(String[] args) {
        Person p=new Person();
        ReflectDemo rd=new ReflectDemo(p);

    }

}</pre>
<p>结果:同上</p>
<pre>========获取方法信息============
public java.lang.String com.pb.Reflect.classinfo.Person.getGender()
public void com.pb.Reflect.classinfo.Person.setGender(java.lang.String)
public int com.pb.Reflect.classinfo.Person.getAge()
public void com.pb.Reflect.classinfo.Person.setAge(int)
public java.lang.String com.pb.Reflect.classinfo.Person.toString()
private java.lang.String com.pb.Reflect.classinfo.Person.getName()
private void com.pb.Reflect.classinfo.Person.setName(java.lang.String)
========获取出方法信息结束============
========获取成员属性信息============
private java.lang.String com.pb.Reflect.classinfo.Person.name
private java.lang.String com.pb.Reflect.classinfo.Person.gender
private int com.pb.Reflect.classinfo.Person.age
========获取成员属性信息结束============
========获取成员构造方法信息============
public com.pb.Reflect.classinfo.Person()
public com.pb.Reflect.classinfo.Person(java.lang.String,java.lang.String,int)
========获取成员构造方法信息结束============</pre>

<h3>七、第三种方法类的.class属性</h3>
<p>Person类同上</p>
<p>测试类:</p>
<pre>package com.pb.Reflect.classinfo;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class TestReflection {

    public static void main(String[] args) {
        /*第二种方法
        Person p=new Person();
        ReflectDemo rd=new ReflectDemo(p);
*/

        /*
         * 第三种方式.class属性
         */
        Class cla=Person.class;
        //利用Class对象的cla的自审,返回方法对象集合
                Method [] method=cla.getDeclaredMethods(); //返回所有的方法
                System.out.println("========获取方法信息============");
                for (Method meth : method) {
                    //遍历method数组，并输出方法信息
                    System.out.println(meth.toString());
                }
                System.out.println("========获取出方法信息结束============");
                //获取属性利用Class对象的cla的自审,返回成员属性对象集合
                 Field [] field=cla.getDeclaredFields();
                    System.out.println("========获取成员属性信息============");
                    for (Field f : field) {
                        System.out.println(f.toString());
                    }
                    System.out.println("========获取成员属性信息结束============");
                //获取属性利用Class对象的cla的自审,返回构造方法集合
                    Constructor [] constructor=cla.getDeclaredConstructors();
                    System.out.println("========获取成员构造方法信息============");
                    for (Constructor constru : constructor) {
                        System.out.println(constru.toString());
                    }
                    System.out.println("========获取成员构造方法信息结束============");
    }

}</pre>
<p>结果：</p>
<p>同上</p>
<pre>========获取方法信息============
public java.lang.String com.pb.Reflect.classinfo.Person.getGender()
public void com.pb.Reflect.classinfo.Person.setGender(java.lang.String)
public int com.pb.Reflect.classinfo.Person.getAge()
public void com.pb.Reflect.classinfo.Person.setAge(int)
public java.lang.String com.pb.Reflect.classinfo.Person.toString()
private java.lang.String com.pb.Reflect.classinfo.Person.getName()
private void com.pb.Reflect.classinfo.Person.setName(java.lang.String)
========获取出方法信息结束============
========获取成员属性信息============
private java.lang.String com.pb.Reflect.classinfo.Person.name
private java.lang.String com.pb.Reflect.classinfo.Person.gender
private int com.pb.Reflect.classinfo.Person.age
========获取成员属性信息结束============
========获取成员构造方法信息============
public com.pb.Reflect.classinfo.Person()
public com.pb.Reflect.classinfo.Person(java.lang.String,java.lang.String,int)
========获取成员构造方法信息结束============</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-08 04:04:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java从零开始学四十(反射简述一)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xvdYk4.html" rel="bookmark">Java从零开始学四十一&lpar;反射简述二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.实例化Class类对象 实例化Class类对象的方法有三种: 第一种:通过forName()方法 第二种:类.class 第三种:对象.getClass() 二.Class类的常用方法 No. 方法 类型 描述 1 public static Class&lt;?&gt; forName(String className) throws ClassNotFoundException 普通 传入完整的“包.类”名称实例化Class对象 2 public Constructor[] getConstruc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eny153.html" rel="bookmark">Java从零开始学四十二&lpar;DOM解析XML&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.DOM解析XML xml文件 favorite.xml &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; standalone=&quot;no&quot;?&gt; &lt;PhoneInfo name=&quot;手机品牌&quot;&gt; &lt;Brand name=&quot;华为&quot;&gt; &lt;Type name=&quot;U8650&quot;&gt; &lt;/Type&gt; &lt;/Brand			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AZrOZM.html" rel="bookmark">Java从零开始学四十五（Socket编程基础&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.网络编程中两个主要的问题 一个是如何准确的定位网络上一台或多台主机,另一个就是找到主机后如何可靠高效的进行数据传输. 在TCP/IP协议中IP层主要负责网络主机的定位,数据传输的路由,由IP地址可以唯一地确定Internet上的一台主机. 而TCP层则提供面向应用的可靠(tcp)的或非可靠(UDP)的数据传输机制,这是网络编程的主要对象,一般不需要关心IP层是如何处理数据的. 目前较为流行的网络编程模型是客户机/服务器(C/S)结构.即通信双方一方作为服务器等待客户提出请求并予以响应.客户则			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPvJbv3.html" rel="bookmark">Java从零开始学四十四（多线程&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.进程与线程 1.1.进程 进程是应用程序的执行实例. 进程是程序的一次动态执行过程,它经历了从代码加载.执行到执行完毕的一个完整过程,这个过程也是进程本身从产生.发展到最终消亡的过程 特征: 动态产生,动态消亡. 进程是并发性的. 进程独立性.是一个独立运行的基本单位,也是系统分配资源和调度的基本单位 1.2.线程 多线程是实现并发机制的一种有效手段.进程和线程一样,都是实现并发的一个基本单位 线程:进程内部的一个执行单元,它是程序中一个单一的顺序控制流程 特点: 线程依赖进程生存 一个进程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyBZem0.html" rel="bookmark">Java从零开始学四十七&lpar;注解简述&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Java中注解Annotation 什么是注解:用来描述数据的数据(元数据). Java代码里的特殊标记.它为代码中添加用Java程序无法表达的额外信息提供一种形式化的方法,使用我们可以在未来的某一个时刻方便的使得这些注解修饰的程序元素.  作用: 用将由编译器来测试和验证的格式,存储有关程序额外信息 生成 描述符文件,甚至是新的类定义 减轻编写模板代码的负担 使代码更加干净易读 注解和注释不同 注解与普通的代码注释有一定的区别,也有一定的联系.注解和注释都属于对代码的描述: 注释的作用只是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVqvW24.html" rel="bookmark">Java从零开始学四十六（Junit&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.软件测试 软件开发: 项目调研--需求分析--软件设计--程序编码--软件测试--运行维护 软件测试:利用测试工具按照测试方案和流程对产品进行功能和性能测试,使用人工或者自动手段来运行或测试某个系统的过程.目的在于检验是否满足规定的需求,确认预期结果与实际结果之间的差别. 墨盒测试-白盒测试-回归测试-单元测试 二.JUnit-单元测试工具 三.测试Junit测试类 创建被测试类 package com.pb.junit; /** *1.创建被测试类 *2.Junit 3.0或者4.0 这里			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eamVJ0.html" rel="bookmark">Java从零开始学三十三四&lpar;JAVA IO-流简述&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.流概念(stream) File类并不能对文件内容进行读写. 读文件就是指:把文件的内中的数据读取到内存中来 写文件就是指:把内存中的数据写入到文件中去. 通过什么读写文件呢?文件流. 1.1.流概念 一连串流动的字符 1.2.流的特性 先进先出的方式传递信息 一个字节序列 具有方向性:输入流.输出流 二.按照流向划分 输入流:读取数据--InputStream和Reader作为基类 输出流:写入数据--OutputStream和Writer作为基类 一共四个4基类. 其中InputStre			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KaAvy4.html" rel="bookmark">Java从零开始学二十二&lpar;集合Set接口&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Set接口的定义 Set接口也是Collection接口的子接口,但是与Collection或List接口不同的是,Set接口中不能加入重复的元素 Set接口的主要方法与Collection是一致的 Set接口的实例无法像List接口那样进行双向输出.不存在get方法使用Iterator接口来遍历集合 2个常用方法:hasNext方法表示判断是否还有元素可以迭代 next()方法:返回迭代的下一个元素 Set接口的常用子类 散列存放:HashSet 有序存放:TreeSet 二.使用SetH			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47DbnbM.html" rel="bookmark">Java从零开始学三十二&lpar;正则表达式&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.为什么要有正则 正则表达式可以方便的对数据进行匹配,可以执行更加复杂的字符串验证.拆份.替换功能. 例如:现在要求判断一个字符串是否由数字组成,则可以有以下的两种做法: 不使用正则完成 使用正则完成 二.Pattern.Matcher类 如果要想在程序中应用正则表达式则必须依靠Pattern类与Matcher类,这两个类都在java.util.regex包中定义.Pattern类的主要作用是进行正则规范的编写,而Matcher类主要是执行规范,验证一个字符串是否符合其规范. 常用正则规则 N			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgbegM.html" rel="bookmark" class="title">iOS&lowbar;关于手机支持的屏幕方向</a>
					<div>
						设置支持的屏幕方向有两个级别,一个是app级别的,另一个是viewController级别的. app 级别的可以在［target］-［general］-［device orientation］里面设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mkmDM.html" rel="bookmark" class="title">Debian系统执行脚本备份</a>
					<div>
						发现很多人都在debian系统脚本执行的时候,直接crontab -e添加,发现不生效. 应该如下,添加环境.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8YNq3.html" rel="bookmark" class="title">0728二维数组&sol;集合</a>
					<div>
						二维数组int [,] array = new int[5,3];//有五个一维数组,每一个一维数组有3个元素 /打印出来一个“王”这个字string[,] wang = new string[,]{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyVmr4.html" rel="bookmark" class="title">了解HTML CSS格式化排版 文字排版</a>
					<div>
						这里简单的写一些涉及到字体排版中常用到的属性, 大家可以学习查看, 也可以mark下以后看. font-family: &quot;Micrsoft Yahei&quot;; 设置字体 font-si ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYmX5M.html" rel="bookmark" class="title">算法竞赛入门经典行训练指南【计数方法】------2015年1月23日</a>
					<div>
						基础知识整理: (1)加法原理 (2)乘法原理 (3)容斥原理(注意变式问题) (4)排列组合公式的应用及变形: 排列的公式: 其变形为: 与组合的关系如下(以下第一个公式很重要): 排列组合公式的重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aDoBAM.html" rel="bookmark" class="title">编译器之神vim大改造</a>
					<div>
						相信码农都听过两大神器,一是emacs,一是vim.大家都知道e党和v党老是吵架.其实,这并没有什么好吵的,只是每个人都有自己适用的东西.作者接触了vim,也接触过emacs.对于作者,觉得vim更加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvzbv0.html" rel="bookmark" class="title">【selenium自动化&mdash;&mdash;验证码问题】</a>
					<div>
						处理验证码的几种方法: 去掉验证码这是最简单的方法,对于开发人员来说,只是把验证码的相关代码注释掉即可,如果是在测试环境,这样做可省去了测试人员不少麻烦,如果自动化脚本是要在正式环境跑,这样就给系统带 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomDlw3.html" rel="bookmark" class="title">手游系统逻辑档案之通信协议</a>
					<div>
						在没做游戏之前,我主要的任务就是实现各种基于tcp.udp或者串口的通信协议.当我要设计一套基于tcp的网络游戏协议时,感觉应该很简单,以前各种国际标准的协议都实现过,自定义的协议还不手到擒来.然而事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQqpA4.html" rel="bookmark" class="title">HBase Shell输入命令无法删除问题解决技巧</a>
					<div>
						一.引言: HBase shell使用过程中,使用CRT客户端,命令输入后无法删除一直困绕着我,今天终于受不了,几番度娘,谷哥之后,终于有了解决方法,特共享给大家.二.操作步骤secureCRT中,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWY1jk3.html" rel="bookmark" class="title">poj1087  网络最大流</a>
					<div>
						http://poj.org/problem?id=1087 Description You are in charge of setting up the press room for the in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vQm9j0.html" rel="bookmark" class="title">关于SQL Server镜像的一个小误区</a>
					<div>
						昨天晚上突然接到客户的电话, 说在配置了镜像的生产环境数据库下修改 “已提交读快照” 选项的时候报错, 需要先取消镜像然后再重新搭建.悲催的是这是个近TB的数据库,问我有没有什么快速的方法.于是我就问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpPpA0.html" rel="bookmark" class="title">数据一致性&lpar;consistency&rpar;、服务可用性&lpar;availability&rpar;、分区容错性&lpar;partition-tolerance&rpar;</a>
					<div>
						分布式系统理论基础 - CAP 2016-04-04 18:27 by bangerlee, 135 阅读, 0 评论, 收藏, 编辑 引言 CAP是分布式系统.特别是分布式存储领域中被讨论最多的理论 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M65pnW4.html" rel="bookmark" class="title">主程的晋升攻略&lpar;8&rpar;：数据层的演进&lpar;上&rpar;</a>
					<div>
						我们用一个做手游的故事来聊聊数据层不断优化提升的演进过程. 10:简单设计 有一天,老板突然说做个山寨版的糖果传奇手游,你接到任务后,分析出游戏的交互频率不大,都是点查询,用mysql能简单搞定.对游 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5XJX0.html" rel="bookmark" class="title">华云神视觉</a>
					<div>
						未来的世界,物联网.大数据.云计算.人工智能.射频识别RFID是物联网的基础(每个事物都有ID标签),数据极度庞大到一定程度和庞大的存储设备是大数据的基础,分布式.并行处理.多进程是云计算的基础,人工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkRgPM.html" rel="bookmark" class="title">如何使用SAE的Storage</a>
					<div>
						转自:http://blog.csdn.net/xujainxing/article/details/8981904 Storage在里面当然可以创建文件夹,只不过无法通过代码创建,而是在后台管理页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqWEm3.html" rel="bookmark" class="title">MVC过滤器的使用总结</a>
					<div>
						一.过滤器的作用 在MVC项目当中,当我们要实现这些功能时:身份验证,异常处理.日志记录,性能统计,如果按照一般的做法那就需要在每个页面重复做这些工作,这样做起来不仅费时费力,代码也会变得冗余难懂,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9Qod4.html" rel="bookmark" class="title">POI导出Excel&mdash;&mdash;（三）</a>
					<div>
						Jar包 Java代码 package POI; import java.io.File; import java.io.FileOutputStream; import java.io.IOExce ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbW273.html" rel="bookmark" class="title">【笔记】js Array&period;prototype&period;slice&period;call&lpar;arguments&rpar; 将函数的参数转换为数组方法的见解</a>
					<div>
						我们知道函数里面的参数实际上是一个以数组形式储存的对象 但它并非一个数组 如果我们要将它转换为数组可以调用Array.prototype.slice() 这个方法 分析一下这个方法: Array.pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRnEA3.html" rel="bookmark" class="title">Java中的return关键字</a>
					<div>
						Java常见面试题之一: try {}里有一个return语句,那么紧跟在这个try后的finally {}里的code会不会被执行,什么时候被执行,在return前还是后?  请看下面程序就可以解释 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynVQm0.html" rel="bookmark" class="title">Sublime Text 编辑器 插件 之 &amp;quot&semi;Sublime Alignment&amp;quot&semi; 详解</a>
					<div>
						作者:shede333主页:http://my.oschina.net/shede333版权声明:原创文章,版权声明:自由转载-非商用-非衍生-保持署名 | [Creative Commons BY- ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
